/*
clientack.cpp 
Copyright (C) 2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "clientack.h"

namespace bhpos{

namespace service{
   
   
CClientAck::CClientAck()
{
   client=0;
   bAck=false;
}

CClientAck::~CClientAck()
{
}

CClientAck::CClientAck(int i, bool b)
{
   client=i;
   bAck=b;
}

CClientAck::CClientAck(const CClientAck& ca)
{
   client=ca.client;
   bAck=ca.bAck;
}

CClientAck &CClientAck::operator=(const CClientAck& ca)
{
   this->client=ca.client;
   this->bAck=ca.bAck;
   
   return *this;
}

bool CClientAck::operator==(const CClientAck& ca)
{
   if(client==ca.client) return true;
   return false;
}

bool CClientAck::operator!=(const CClientAck& ca)
{
   if(client!=ca.client) return true;
   return false;
}

bool CClientAck::operator==(const int i)
{
   if(client==i) return true;
   return false;
}

bool CClientAck::operator!=(const int i)
{
   if(client!=i) return true;
   return false;
}

bool CClientAck::operator<(const CClientAck& ca)
{
   if(client < ca.client) return true;
   return false;
}

void CClientAck::Ack()
{
   bAck=true;
}

void CClientAck::Clear()
{
   bAck=false;
}

bool CClientAck::Status()
{
   return bAck;
}

}

}
