/*
clientackcollector.cpp 
Copyright (C) 2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/

#include <list>
#include <algorithm>
#include "clientack.h"


namespace bhpos{

namespace service{

CClientAckCollector::CClientAckCollector()
{
   current=0;
}

CClientAckCollector::CClientAckCollector(int s, int d, int g, int p)
{
   current=0;
   site=s;
   dept=d;
   group=g;
   post=p;
}

CClientAckCollector::~CClientAckCollector()
{
   clients.clear();
}

void CClientAckCollector::Clear()
{
   std::list<CClientAck>::iterator cai;
}

int CClientAckCollector::Add(CClientAck& ca)
{
   clients.push_back(ca);  
   return clients.size();
}

int CClientAckCollector::Ack(int i)
{
   std::list<CClientAck>::iterator cai=find(clients.begin(), clients.end(), i);
 
	if(cai!=clients.end()){
		cai->Ack();
		return 1;
	}
	return 0;
}

void CClientAckCollector::Reset()
{
   current=0;
}

int CClientAckCollector::NumLeft()
{
	int count=0;
	std::list<CClientAck>::iterator cai;
   
	for(cai=clients.begin(); cai!=clients.end(); cai++){
	   if(!cai->Status()){
	      count++;
	   }
	}
	return (clients.size() - count);
}

int CClientAckCollector::GetNext()
{
   std::list<CClientAck>::iterator cai;
   current++;
	for(cai=clients.begin(); cai!=clients.end(); cai++){
	   
	} 
   return 0;
}

int CClientAckCollector::Status()
{
   CClientAck                 ack;
   std::list<CClientAck>::iterator cai;
   
	for(cai=clients.begin(); cai!=clients.end(); cai++){
	   if(!cai->Status()){
	      return 1;
	   }
	} 
   return 0;
}

}

}
