/*
clientinfo.cpp - need I say more. 
Copyright (C) 2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
#include <pthread.h>
#include <cstdio>
#include <cstring>

#include "pos.h"
#include "ctransitems.h"
#include "clientinfo.h"

namespace bhpos{

CUserInfo::CUserInfo()
{
   ID=0;
   name[0]=0;
   num_nosale=0;
   num_voidtrans=0;
   num_trans=0;
   start_amount=0.0;
   payin_amount=0.0;
   payout_amount=0.0;
   total_transacted=0.0;
   num_login=0;
	num_seconds=0;
   start=0;
   end=0;
   total=0;
}

CUserInfo::CUserInfo(int id)
{
   ID=id;
   name[0]=0;
   num_nosale=0;
   num_voidtrans=0;
   num_trans=0;
   start_amount=0.0;
   payin_amount=0.0;
   payout_amount=0.0;
   total_transacted=0.0;
   num_login=0;
	num_seconds=0;
	start=time(NULL);
   start=0;
   end=0;
   total=0;
}

CUserInfo::CUserInfo(const CUserInfo& ui)
{
   ID=ui.ID;
   strcpy(name, ui.name);
   num_nosale=ui.num_nosale;
   num_voidtrans=ui.num_voidtrans;
   num_trans=ui.num_trans;
   start_amount=ui.start_amount;
   payin_amount=ui.payin_amount;
   payout_amount=ui.payout_amount;
   total_transacted=ui.total_transacted;
   num_login=ui.num_login;
	num_seconds=ui.num_seconds;
   start=ui.start;
   end=ui.end;
   total=ui.total;
}

CUserInfo::~CUserInfo()
{
}

CUserInfo &CUserInfo::operator=(const CUserInfo& ui)
{
   this->ID=ui.ID;
   strcpy(this->name, ui.name);
   this->num_nosale=ui.num_nosale;
   this->num_voidtrans=ui.num_voidtrans;
   this->num_trans=ui.num_trans;
   this->start_amount=ui.start_amount;
   this->payin_amount=ui.payin_amount;
   this->payout_amount=ui.payout_amount;
   this->total_transacted=ui.total_transacted;
   this->num_login=ui.num_login;
	this->num_seconds=ui.num_seconds;
   this->start=ui.start;
   this->end=ui.end;
   this->total=ui.total;
   
   return *this;
}

bool CUserInfo::operator==(CUserInfo const& ui)
{
   if(ID==ui.ID) return true;
   return false;
}

bool CUserInfo::operator!=(CUserInfo const& ui)
{
   if(ID!=ui.ID) return true;
   return false;
}

bool CUserInfo::operator==(int const& i)
{
   if(ID==i) return true;
   return false;
}

bool CUserInfo::operator!=(int const& i)
{
   if(ID!=i) return true;
   return false;
}

int CUserInfo::GetParameter(unsigned int p, void *v)
{
   if(v==NULL) return 1;
   
   switch(p){
   case BHUI_PARAM_USERID:
      *((unsigned int *) v)=ID;
		break;
   case BHUI_PARAM_NUMNOSALE:
      *((unsigned int *) v)=num_nosale;
		break;
   case BHUI_PARAM_NUMVOID:
      *((unsigned int *) v)=num_voidtrans;
		break;
   case BHUI_PARAM_NUMTRANS:
      *((unsigned int *) v)=num_trans;
		break;
   case BHUI_PARAM_STARTAMOUNT:
      *((double *) v)=start_amount;
		break;
   case BHUI_PARAM_PAYINAMOUNT:
      *((double *) v)=payin_amount;
		break;
   case BHUI_PARAM_PAYOUTAMOUNT:
      *((double *) v)=payout_amount;
		break;
   case BHUI_PARAM_TRANSAMOUNT:
      *((double *) v)=total_transacted;
		break;
   case BHUI_PARAM_NUMLOGIN:
      *((unsigned int *) v)=num_login;
		break;
   case BHUI_PARAM_STARTTIME:
      *((time_t *) v)=start;
		break;
   case BHUI_PARAM_CURRENTTIME:
      *((time_t *) v)=start;
		break;
   case BHUI_PARAM_ENDTIME:
      *((time_t *) v)=start;
		break;
   case BHUI_PARAM_TOTALTIME:
      *((time_t *) v)=start;
		break;
   }
  
   return 0;
}

int CUserInfo::SetParameter(unsigned int p, void *v)
{
   if(v==NULL) return 1;
   
   switch(p){
   case BHUI_PARAM_USERID:
      ID=*((unsigned int *) v);
		break;
   case BHUI_PARAM_NUMNOSALE:
      num_nosale=*((unsigned int *) v);
		break;
   case BHUI_PARAM_NUMVOID:
      num_voidtrans=*((unsigned int *) v);
		break;
   case BHUI_PARAM_NUMTRANS:
      num_trans=*((unsigned int *) v);
		break;
   case BHUI_PARAM_STARTAMOUNT:
      start_amount=*((double *) v);
		break;
   case BHUI_PARAM_PAYINAMOUNT:
      payin_amount=*((double *) v);
		break;
   case BHUI_PARAM_PAYOUTAMOUNT:
      payout_amount=*((double *) v);
		break;
   case BHUI_PARAM_TRANSAMOUNT:
      total_transacted=*((double *) v);
		break;
   case BHUI_PARAM_NUMLOGIN:
      num_login=*((unsigned int *) v);
		break;
   case BHUI_PARAM_STARTTIME:
      start=*((time_t *) v);
		break;
   case BHUI_PARAM_CURRENTTIME:
      start=*((time_t *) v);
		break;
   case BHUI_PARAM_ENDTIME:
      start=*((time_t *) v);
		break;
   case BHUI_PARAM_TOTALTIME:
      start=*((time_t *) v);
		break;
   }
  
   return 0;
}

void CUserInfo::Reset()
{
   num_trans=0;
   num_nosale=0;
   num_voidtrans=0;
   start_amount=0.0;
   payin_amount=0.0;
   payout_amount=0.0;
   total_transacted=0.0;
   num_login=0;
   start=0;
   current=0;
   end=0;
   total=0;
}

int CUserInfo::Login()
{
   if(start==0){
      start=time(NULL);
   }
   num_login++;
   current=time(NULL);
   
   return 0;
}

int  CUserInfo::Logout()
{
   if(end==0){
      end=time(NULL);
   }
   total+=time(NULL)-current;
   
   return 0;
}

int  CUserInfo::AddTrans(double a, int flags)
{
   switch(flags){
   case BHUI_TRANS_NORMAL:
      num_trans++;
      total_transacted+=a;
      break;
   case BHUI_TRANS_NOSALE:
      num_nosale++;
      break;
   case BHUI_TRANS_VOIDSALE:
      num_voidtrans++;
      break;
   }
   
   return 0;
}

void CUserInfo::ClockIn()
{ 
   current=time(NULL);
}

void CUserInfo::FillData(BhBlindBalanceReply *h)
{
   if(h==NULL) return;
   h->opening_balance=start_amount;
   //h->amount_transacted=total_transacted;
}

void CUserInfo::FillData(BhServiceUserSumItem *h)
{
   return;
   if(h==NULL) return;
      /*
   h->ID=ID;
   strcpy(h->name, name);
   h->num_nosale=num_nosale;
   h->num_voidsale=num_voidtrans;
   h->num_trans=num_trans;
   h->total_transacted=total_transacted;
   h->num_login=num_login;
   h->start=start;
   h->end=end;
   h->total=total;*/
}
   

////////////////////////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////////////////////

CClientInfo::CClientInfo()
{
	status=0;
	mode=0;
	memset(&hdr, 0, sizeof(hdr));
	Error=0;
	dbID=0;
	userID=0;
	bHandleMultiTrans=false;
	bTransLeaveOpen=false;
	num_transactions=0;
	cash_start=0.0f;
	cash_in_drawer=0.0f;
	upper_tidemark=0.0f;
	lower_tidemark=0.0f;
	time(&client_start);
	memset(&user_logon, 0, sizeof(user_logon));
	memset(&macaddr, 0, sizeof(macaddr));
	time(&now);
	
	bKeepalive=false;
	retries=0;
	max_retries=3;
	last_msg=clock();
	
	currencyID=0;
	localeID=0;
	
   duration=0;
	request_type=0;
	
	num_users=0;
	num_cash=0;
   total_cash=0.0;
   num_cheque=0;
   total_cheque=0.0;
   num_token=0;
   total_token=0.0;
   num_credit=0;
   total_credit=0.0;
   num_smartc=0;
   total_smartc=0.0;
   num_voucher=0;
   total_voucher=0.0;
   num_other=0;
   total_other=0.0;
   
   memset(&ts, 0, sizeof(BhTransCommit));
	
	pthread_mutexattr_t attrib;
	pthread_mutex_init(&busy, &attrib);
}

CClientInfo::CClientInfo(const CClientInfo& pi)
{
	status=pi.status;
	mode=pi.mode;
	
	users=pi.users;
	station=pi.station;
	cash=pi.cash;
	
	Error=pi.Error;
	userID=pi.userID;
	dbID=pi.dbID;
	bHandleMultiTrans=pi.bHandleMultiTrans;
	bTransLeaveOpen=pi.bTransLeaveOpen;
	num_transactions=pi.num_transactions;
	cash_start=pi.cash_start;
	cash_in_drawer=pi.cash_in_drawer;
	memcpy(&hdr, &pi.hdr, sizeof(hdr));
	cash_start=pi.cash_start;
	cash_in_drawer=pi.cash_in_drawer;
	upper_tidemark=pi.upper_tidemark;
	lower_tidemark=pi.lower_tidemark;

	memcpy(&client_start, &pi.client_start, sizeof(client_start));
	memcpy(&user_logon, &pi.user_logon, sizeof(user_logon));
	memcpy(macaddr, pi.macaddr, sizeof(macaddr));
	memcpy(&now, &pi.now, sizeof(now));

	bKeepalive=pi.bKeepalive;
	retries=pi.retries;
	max_retries=pi.max_retries;
	last_msg=pi.last_msg;

   currencyID=pi.currencyID;
	localeID=pi.localeID;

   duration=pi.duration;

   num_users=pi.num_users;	
	num_cash=pi.num_cash;
   total_cash=pi.total_cash;
   num_cheque=pi.num_cheque;
   total_cheque=pi.total_cheque;
   num_smartc=pi.num_smartc;
   total_smartc=pi.total_smartc;
   num_token=pi.num_token;
   total_token=pi.total_token;
   num_credit=pi.num_credit;
   total_credit=pi.total_credit;
   num_voucher=pi.num_voucher;
   total_voucher=pi.total_voucher;
   num_other=pi.num_other;
   total_other=pi.total_other;

   memcpy(&ts, &pi.ts, sizeof(BhTransCommit));
	
	trans=pi.trans;
}

CClientInfo &CClientInfo::operator=(const CClientInfo& pi)
{
	this->status=pi.status;
	this->mode=pi.mode;
	
	this->users=pi.users;
	this->station=pi.station;
	this->cash=pi.cash;
	
	this->Error=pi.Error;
	this->userID=pi.userID;
	this->dbID=pi.dbID;
	this->bHandleMultiTrans=pi.bHandleMultiTrans;
	this->bTransLeaveOpen=pi.bTransLeaveOpen;
	this->num_transactions=pi.num_transactions;
	this->cash_start=pi.cash_start;
	this->cash_in_drawer=pi.cash_in_drawer;
	memcpy(&this->hdr, &pi.hdr, sizeof(hdr));
	this->cash_start=pi.cash_start;
	this->cash_in_drawer=pi.cash_in_drawer;
	this->upper_tidemark=pi.upper_tidemark;
	this->lower_tidemark=pi.lower_tidemark;

	memcpy(&this->client_start, &pi.client_start, sizeof(client_start));
	memcpy(&this->user_logon, &pi.user_logon, sizeof(user_logon));
	memcpy(&this->macaddr, pi.macaddr, sizeof(macaddr));
	memcpy(&this->now, &pi.now, sizeof(now));

	this->bKeepalive=pi.bKeepalive;
	this->retries=pi.retries;
	this->max_retries=pi.max_retries;
	this->last_msg=pi.last_msg;
	
	this->currencyID=pi.currencyID;
	this->localeID=pi.localeID;
   this->duration=pi.duration;
	
	this->num_users=pi.num_users;
	this->num_cash=pi.num_cash;
   this->total_cash=pi.total_cash;
   this->num_cheque=pi.num_cheque;
   this->total_cheque=pi.total_cheque;
   this->num_smartc=pi.num_smartc;
   this->total_smartc=pi.total_smartc;
   this->num_token=pi.num_token;
   this->total_token=pi.total_token;
   this->num_credit=pi.num_credit;
   this->total_credit=pi.total_credit;
   this->num_voucher=pi.num_voucher;
   this->total_voucher=pi.total_voucher;
   this->num_other=pi.num_other;
   this->total_other=pi.total_other;
	
   memcpy(&this->ts, &pi.ts, sizeof(BhTransCommit));
	
	this->trans=pi.trans;
	
	return *this;
}

bool CClientInfo::operator==(CClientInfo const& c)
{
	if(hdr.sessionID==c.hdr.sessionID) return true;
	return false;
}

bool CClientInfo::operator!=(CClientInfo const& c)
{
	if(hdr.sessionID!=c.hdr.sessionID) return true;
	return false;
}

bool CClientInfo::operator<(CClientInfo const& c)
{
	if(hdr.sessionID < c.hdr.sessionID) return true;
	return false;
}
  
CClientInfo::~CClientInfo()
{
   users.clear();
	pthread_mutex_destroy(&busy);
}

void CClientInfo::Reset()
{
   duration=0;
   num_users=0;
	num_cash=0;
   total_cash=0.0;
   num_cheque=0;
   total_cheque=0.0;
   num_token=0;
   total_token=0.0;
   num_credit=0;
   total_credit=0.0;
   num_smartc=0;
   total_smartc=0.0;
   num_voucher=0;
   total_voucher=0.0;
   num_other=0;
   total_other=0.0;
   memset(&ts, 0, sizeof(BhTransCommit));
   
	users.clear();
}

bool CClientInfo::Lock()
{
	return pthread_mutex_lock(&busy);
}
bool CClientInfo::Release()
{
	return pthread_mutex_unlock(&busy);
}

void CClientInfo::FlagKeepalive(bool b)
{
	if(!b){
		bKeepalive=false;
		retries=0;
		return;
	}
	
	if(bKeepalive){
		retries+=1;
	}
	if(retries==max_retries){
		// disconnected, flag as such, system will wait on silent reconnect
		status=POST_STATUS_DISCONNECTED;
	}
	else bKeepalive=true;
}

int CClientInfo::SetParameter(unsigned int param, void *v)
{
	switch(param){
	case BHCI_PARAM_STATUS:
		status=*((unsigned int *) v);
		break;
	case BHCI_PARAM_MODE:
		mode=*((unsigned int *) v);
		break;
	case BHCI_PARAM_SESSID:
		hdr.sessionID=*((int *) v);
		break;
	case BHCI_PARAM_CURRENCYID:
	   currencyID=*((int *) v);
		break;
	case BHCI_PARAM_LOCALEID:
	   localeID=*((int *) v);
		break;
   case BHCI_PARAM_TRANSVOID:
   {
      std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), userID);
		if(iter!=users.end()){
		   iter->AddTrans(0.0, BHUI_TRANS_VOIDSALE);
		}
   }
      break;
   case BHCI_PARAM_NOSALE:
   {
      std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), userID);
		if(iter!=users.end()){
		   iter->AddTrans(0.0, BHUI_TRANS_NOSALE);
		}
   }
      break;
	case BHCI_PARAM_USERID:
	{
		userID=*((int *) v);
		std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), userID);
		num_users++;
   }
		break;
	case BHCI_PARAM_LOGIN:
	{
		int uid=*((int *) v);
		std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), uid);
		if(iter!=users.end()){
		   iter->Login();
		}
   }
		break;
	case BHCI_PARAM_LOGOUT:
	{
		int uid=*((int *) v);
		std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), uid);
		if(iter!=users.end()){
		   iter->Logout();
		}
   }
		break;
	case BHCI_PARAM_CASHSTART:
		cash_start=*((double *) v);
		break;
	case BHCI_PARAM_CASHSET:
		cash_in_drawer=*((double *) v);
		break;
	case BHCI_PARAM_CASHADJUST:
		cash_in_drawer+=*((double *) v);
		cash.Remove(*((double *) v));
		break;
	case BHCI_PARAM_CASHADD:
		cash_in_drawer+=*((double *) v);
		cash.AddTo(*((double *) v));
		break;
	case BHCI_PARAM_CASHSUBTRACT:
		cash_in_drawer-=*((double *) v);
		cash.Remove(*((double *) v));
		break;
   case BHCI_PARAM_CUSTID:
      ts.customerID=*((int *) v);
      break;
   case BHCI_PARAM_DURATION:
      duration=*((int *) v);
      break;
	case BHCI_PARAM_INCTRANS:
		break;
	case BHCI_PARAM_DECTRANS:
	   break;
	case BHCI_PARAM_MAC:
		memcpy(macaddr, (unsigned char *) v, 6);
		break;
	case BHCI_PARAM_LTIDEMARK:
		lower_tidemark=*((double *) v);
		break; 
	case BHCI_PARAM_HTIDEMARK:
		upper_tidemark=*((double *) v);
		break;
	case BHCI_PARAM_TRANSOPEN:
		bTransLeaveOpen=*((bool *) v);
		break;
	case BHCI_PARAM_MULTITRANS:
		bHandleMultiTrans=*((bool *) v);
		break;
	}
	
	return 0;
}

int CClientInfo::GetParameter(unsigned int param, void *v)
{
	switch(param){
	case BHCI_PARAM_STATUS:
		*((unsigned int *) v)=status;
		break;
	case BHCI_PARAM_MODE:
		*((unsigned int *) v)=mode;
		break;
	case BHCI_PARAM_SESSID:
		*((int *) v)=hdr.sessionID;
		break;
	case BHCI_PARAM_USERID:
		*((int *) v)=userID;
		break;
	case BHCI_PARAM_CURRENCYID:
	   *((int *) v)=currencyID;
		break;
	case BHCI_PARAM_LOCALEID:
	   *((int *) v)=localeID;
		break;
	case BHCI_PARAM_CUSTID:
      *((int *) v)=ts.customerID;
      break;
   case BHCI_PARAM_DURATION:
      *((int *) v)=duration;
      break;
	case BHCI_PARAM_STATIONID:
		*((int *) v)=station.GetID();
		break;
	case BHCI_PARAM_SITEID:
	{
	   int s;  
	   station.GetSite(&s, NULL);
	   *((int *) v)=s;
	}
	   break;
	case BHCI_PARAM_CASHSTART:
		*((double *) v)=cash_start;
		break;
	case BHCI_PARAM_CASHSET:
		*((double *) v)=cash_in_drawer;
		break;
	case BHCI_PARAM_INCTRANS:
		break;
	case BHCI_PARAM_DECTRANS:
		break;
	case BHCI_PARAM_MAC:
		memcpy((unsigned char *) v, macaddr, 6);
		break;
	case BHCI_PARAM_LTIDEMARK:
		*((double *) v)=lower_tidemark;
		break; 
	case BHCI_PARAM_HTIDEMARK:
		*((double *) v)=upper_tidemark;
		break;
	case BHCI_PARAM_TRANSOPEN:
		*((bool *) v)=bTransLeaveOpen;
		break;
	case BHCI_PARAM_MULTITRANS:
		*((bool *) v)=bHandleMultiTrans;
		break;
	case BHCI_PARAM_TRANSSUM:
		memcpy((BhTransCommit *) v, &ts, sizeof(BhTransCommit));
		break;
	case BHCI_PARAM_TIDEMARK:
	   if(upper_tidemark!=0.0 && lower_tidemark!=0.0){
         if(cash_in_drawer > upper_tidemark){
            *((double *) v)=cash_in_drawer - upper_tidemark;
            break;
         }
         else if(cash_in_drawer < lower_tidemark){
            *((double *) v)=cash_in_drawer - lower_tidemark;
            break;
         }
      }
      *((double *) v)=0.0;
      break;
	}
	return 0;
}

void CClientInfo::SetStation(CStation& s)
{
	station=s;
}
CStation& CClientInfo::GetStation()
{
	return station;
}

int CClientInfo::GetNumber(int t, int *a, double *am)
{
   switch(t){
   case PTYPE_CASH:
      *a=num_cash;
      *am=total_cash;
      break;
   case PTYPE_CREDIT:
      *a=num_credit;
      *am=total_credit;
      break;
   case PTYPE_CHEQUE:
      *a=num_cheque;
      *am=total_cheque;
      break;
   case PTYPE_SMARTC:
      *a=num_smartc;
      *am=total_smartc;
      break;
   /*
   case PTYPE_TOKEN:
      *a=num_token;
      *am=total_token;
      break;
   case PTYPE_VOUCHER:
      *a=num_voucher;
      *am=total_voucher;
      break;*/
   case PTYPE_OTHER:
      *a=num_other;
      *am=total_other;
      break;
   case BHCI_NUM_USERS:
      *a=num_users;
      break;
   case BHCI_NUM_ITEMS:
      *a=ts.total_items;
   case BHCI_NUM_UITEMS:
      *a=ts.total_unknownitems;
      break;
   case BHCI_NUM_PITEMS:
      *a=ts.total_payment_types;
      break;
   case BHCI_NUM_TAX:
      *am=ts.total_tax;
      break;
   case BHCI_NUM_DISCOUNT:
      *am=ts.total_discount;
      break;
   case BHCI_NUM_TOTAL:
      *am=ts.total;
      break;
	case BHCI_NUM_CASHIND:
		*am=cash_in_drawer;
		break;
   }
   return 0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~ Transaction Stuff  ~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

bool CClientInfo::IsDelivery()
{
	return ts.delivery;
}

int CClientInfo::NumTrans()
{
	return trans.NumTrans();
}

int CClientInfo::NumItems(int tid, BhItemType type)
{
	return trans.NumItems(tid, type);
}

int CClientInfo::NewTrans(int tid, int nid)
{
	int ret=trans.Add(tid);
   trans.SetNameID(tid, nid);
   return ret;
}

int CClientInfo::GetNameID(int tid)
{
   return trans.GetNameID(tid);
}

void CClientInfo::ClearTrans(int tid)
{
	// update things...
	num_transactions--;
	
	trans.Clear(tid);
}

void CClientInfo::ClearAllTrans()
{
   trans.ClearAll();
}

bool CClientInfo::GetTransaction(int transID, CTransItems& ct)
{
	return trans.Get(transID, ct);
}

bool CClientInfo::UpdateTrans(int tid, CTransItems& ct)
{
	return trans.Update(tid, ct);
}

bool CClientInfo::TransCommit(BhTransCommit *tc)
{
   CTransItems t;
   
	//if(tc->transID!=TransactionID) return true;
	ts.flags=tc->flags;
	ts.delivery=tc->delivery;
	ts.customerID=tc->customerID;
	ts.total_items+=tc->total_items;
	ts.total_unknownitems+=tc->total_unknownitems;
	ts.total_returnitems+=tc->total_returnitems;
	ts.total_rentalitems+=ts.total_rentalitems;
   ts.total_laybyitems+=ts.total_laybyitems;
	ts.total_payment_types+=tc->total_payment_types;
	ts.total_tax+=tc->total_tax;
	ts.total_discount+=tc->total_discount;
	ts.change+=tc->change;
	ts.total+=tc->total;
	
	num_transactions++;

   if(trans.Get(tc->transID, t)){
      t.SetNumber(BHNUM_TAX, tc->total_tax);
      t.SetNumber(BHNUM_DISCOUNT, tc->total_discount);
      t.SetNumber(BHNUM_CHANGE, tc->change);
      t.SetNumber(BHNUM_TOTAL, tc->total);
      trans.Update(tc->transID, t);
   }
	return false;
}

bool CClientInfo::TransPLU(int tid, CSaleItem& si)
{
   trans.AddItem(tid, si, true);
   return false;
}

bool CClientInfo::TransPLU(int tid, BhTransItem *pc)
{
	CSaleItem	si;

	si.SetPLU(pc->PLU);
	si.SetQuantity(pc->quantity);
	si.SetFlags(pc->flags);
	si.SetType(pc->type);
	
	return trans.AddItem(tid, si, true);
}

bool CClientInfo::TransPLU(int tid, BhTransPluCommit *pc)
{
	BhTransItem	*ti=(BhTransItem *) pc->items;
	CSaleItem	si;
	
	for(int i=0; i < pc->num_items; i++){
		si.SetPLU(ti->PLU);
		si.SetQuantity(ti->quantity);
		si.SetFlags(ti->flags);
		si.SetType(ti->type);
		trans.AddItem(tid, si, true);
		ti++;
		if(ti==NULL){
			return true;
		}
	}
	return false;
}
/*
bool CClientInfo::TransReturnPLU(int tid, BhTransItem *pc)
{
	CSaleItem	si;

	si.SetPLU(pc->PLU);
	si.SetQuantity(pc->quantity);
	si.SetFlags(pc->flags);
	
	trans.AddReturn(tid, si);
	
	return false;
}

bool CClientInfo::TransReturnPLU(int tid, BhTransPluCommit *pc)
{
	BhTransItem	*ti=(BhTransItem *) pc->items;
	CSaleItem	si;
	
	for(int i=0; i < pc->num_items; i++){
		si.SetPLU(ti->PLU);
		si.SetQuantity(ti->quantity);
		si.SetFlags(ti->flags);
		trans.AddReturn(tid, si);
		ti++;
		if(ti==NULL){
			return true;
		}
	}
	return false;
}
*/
bool CClientInfo::TransPLU(int tid, BhTransItemUPLU *pc)
{
	CSaleItem	si;
	
	si.SetPLU(pc->PLU);
	si.SetDispText(pc->description);
	si.SetQuantity(pc->quantity);
	si.SetFlags(pc->flags);
	si.SetPrice(pc->unitPrice);
   si.SetTax(pc->tax);
	si.SetType(BHSI_SITYPE_UPLU);
	
	trans.AddItem(tid, si, true);
	
	return false;
}

bool CClientInfo::TransPLU(int tid, BhRetPLUreply *pc)
{
   CSaleItem	si;
	
	si.SetPLU(pc->PLU);
	si.SetDispText(pc->displayText);
	si.SetRecText(pc->recuText);
	si.SetQuantity(pc->quantity);
	si.SetFlags(pc->flags);
	si.SetPrice(pc->unitPrice);
	si.SetType(pc->type);
	
	si.SetSite(pc->site);
   si.SetDept(pc->dept);
   si.SetGroup(pc->group);
   si.SetStation(pc->station);
   si.SetUser(pc->user);
   
   BhDateTime dt(pc->when);
   si.SetTimestamp(dt);
	
	trans.AddItem(tid, si, true);
	
	return false;
}

bool CClientInfo::TransPay(int tid, CPayItem& pi)
{
   return trans.AddPayment(tid, pi, false);
}

bool CClientInfo::TransPay(BhTransPaymentCommit *pc)
{
	CPayItem		 pi;
	
	BhTransPayment	*tp=(BhTransPayment *) pc->payment;
	for(int i=0; i < pc->num_items; i++){
		pi.SetAmount(tp->amount);
		pi.SetID((BhPayType) tp->type);
		pi.SetFlags((BhPayTypeFlag) tp->flags);
		
		switch(tp->type){
		case PTYPE_CASH:
         num_cash++;
         total_cash+=tp->amount;
         break;
      case PTYPE_CREDIT:
         num_credit++;
         total_credit+=tp->amount;
      break;
      case PTYPE_CHEQUE:
         num_cheque++;
         total_cheque+=tp->amount;
         break;
      case PTYPE_SMARTC:
         num_smartc++;
         total_smartc+=tp->amount;
         break;
      /*
      case PTYPE_TOKEN:
         num_token++;
         total_token+=tp->amount;
         break;
      case PTYPE_VOUCHER:
         num_voucher++;
         total_voucher+=tp->amount;
         break;*/
      case PTYPE_OTHER:
         num_other++;
         total_other+=tp->amount;
         break;
      }
   
		trans.AddPayment(pc->transID, pi, false);
		tp++;
		if(tp==NULL){
			return true;
		}
	}
	return false;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~ Cash Stuff  ~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void CClientInfo::ClearCash()
{
	cash.Clear();
}

int CClientInfo::AddMonetaryUnit(CMoney& m)
{
	cash.Add(m);
	return 0;
}

void CClientInfo::SetCash(int unit, float value, int amount)
{
	cash.AdjustAmount(unit, value, amount);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~ Other Stuff  ~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void CClientInfo::GetEnteredAt(char *d)
{
   if(d==NULL) return;
   station.GetEnteredAt(d);
}

void CClientInfo::FillMcHdr(BhMcPosMsg *msg)
{
	int temp;
	
	station.GetSite(&temp, NULL);
	msg->site=temp;
	station.GetDept(&temp, NULL);
	msg->dept=temp;
	station.GetGroup(&temp, NULL);
	msg->group=temp;
	msg->post=station.GetID();
}

/*
bool CClientInfo::SetHdr(BhHdr *h)
{
	Lock();
	memcpy(&hdr, h, sizeof(BhHdr));
	
	// auto update some parameters
	switch(hdr->type){
	case BHPOS_TYPE_NULL:
	case BHPOS_TYPE_SYSTEM:
	case BHPOS_TYPE_POST:
	case BHPOS_TYPE_SERVICE:
	case BHPOS_TYPE_INFO:
	case BHPOS_TYPE_SCALES:
	case BHPOS_TYPE_RPRINTER:
	case BHPOS_TYPE_ENTRY:
	case BHPOS_TYPE_ATTENDANCE:
	case BHPOS_TYPE_CUSTOM:
	case BHPOS_TYPE_RAWSQL:
	case BHPOS_TYPE_ERROR:
		break;
	}
	Release();
	return false;
}*/

BhHdr *CClientInfo::GetHdr()
{
	return &hdr;
}

int CClientInfo::UpdateHdr(BhHdr *h)
{
	//if(h->sessionID!=hdr.sessionID) return -1;
	//if(h->msgID < hdr.msgID) return -2;

	hdr.type=h->type;
	hdr.cmd=h->cmd;
	hdr.subcmd=h->subcmd;
	hdr.Ex=h->Ex;
	hdr.msgID=h->msgID;
	hdr.timestamp=h->timestamp;
	
	bKeepalive=false;
	last_msg=clock();
	
	return 0;
}

int CClientInfo::GetLastMsgID()
{
   return hdr.msgID;
}

void CClientInfo::SetLastMsgID(int i)
{
   hdr.msgID=i;
}

void CClientInfo::ResetStart()
{
	time(&client_start);
}

bool CClientInfo::SetSystemTime(time_t *t)
{
	memcpy(&now, t, sizeof(now));
	return false;
}

bool CClientInfo::UserExists(int id)
{
	std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), id);
	if(iter==users.end()) return false;
	return true;
}

bool CClientInfo::AddUser(int id)
{
	CUserInfo ui(id);
	users.push_back(ui);
	return false;
}

void CClientInfo::RemoveUser(int id)
{
   std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), id);
	if(iter==users.end()) return;
	
	users.erase(iter);
}

void CClientInfo::RemoveUser(CUserInfo& ui)
{
   std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), ui);
	if(iter==users.end()) return;
	
	users.erase(iter);
}


void CClientInfo::UserStartClock(int id, bool bStart)
{
	std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), id);
	if(iter==users.end()) return;

	time_t temp;

	if(bStart){
		iter->current=time(NULL);
	}
	else{
		temp=time(NULL);
		iter->num_seconds+=(int)difftime(iter->current, temp);
	}
}

void CClientInfo::ResetUserTime()
{
	time(&user_logon);
}

bool CClientInfo::SetUserTime(time_t *t)
{
	memcpy(&user_logon, t, sizeof(user_logon));
	return false;
}

bool CClientInfo::GetUser(CUserInfo& ui)
{
   std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), ui);
   
   if(iter==users.end()) return true;
   ui=*iter;
   return false;
}

bool CClientInfo::SetUser(CUserInfo& ui)
{
   std::list<CUserInfo>::iterator iter=find(users.begin(), users.end(), ui);
	if(iter==users.end()) return true;
	*iter=ui;
	return false;
}

void CClientInfo::FillUserInfo(BhPosMsg *m)
{
   std::list<CUserInfo>::iterator iter;
   
   BhServiceUserSum *us= (BhServiceUserSum *) m->data;
   BhServiceUserSumItem *usi=us->user;
   us->num_users=users.size();
   
   m->hdr.size=sizeof(us->num_users);

	for(iter=users.begin(); iter!=users.end(); iter++){ 
		iter->FillData(usi);
		usi++;
		m->hdr.size+=sizeof(BhServiceUserSumItem);
	}   
}

void CClientInfo::SetRequest(int t)
{
	time(&request_rx);
	request_type=t;
}
void CClientInfo::AcknowledgeRequest()
{
	request_type=0;
}
int CClientInfo::GetRequest(time_t *when)
{
	if(when!=NULL) memcpy(when, &request_rx, sizeof(time_t));
	return request_type;
}

}
