/*
cmenulist.cpp
Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#include <sys/time.h>
#include "cmenulist.h"

namespace BhPos{

CMenuItem::CMenuItem()
{
   status=BHMENU_STATUS_UNKNOWN;
   id=0;
   menuid=0;
   menuheadingid=0;
   plu="";
   name="";
   description="";
   imageid=0;
   printerid=0;
}

CMenuItem::CMenuItem(CMenuItem const& m)
{
   status=m.status;
   id=m.id;
   menuid=m.menuid;
   menuheadingid=m.menuheadingid;
   plu=m.plu;
   name=m.name;
   description=m.description;
   imageid=m.imageid;
   printerid=m.printerid;
}

CMenuItem::~CMenuItem()
{
}

void CMenuItem::operator=(CMenuItem const& m)
{
   status=m.status;
   id=m.id;
   menuid=m.menuid;
   menuheadingid=m.menuheadingid;
   plu=m.plu;
   name=m.name;
   description=m.description;
   imageid=m.imageid;
   printerid=m.printerid;
}

bool CMenuItem::operator==(CMenuItem const& m)
{
	if(id==m.id) return true;
	return false;
}

bool CMenuItem::operator==(int i)
{	if(id==i) return true;
	return false;
}

bool CMenuItem::operator!=(int i)
{
	if(id!=i) return true;
	return false;
}

bool CMenuItem::operator!=(CMenuItem const& m)
{
	if(id!=m.id) return true;
	return false;
}
BhMenuStatus CMenuItem::GetStatus()
{
   return status;
}

int CMenuItem::GetID()
{
   return id;
}

void CMenuItem::SetStatus(BhMenuStatus s)
{
   status=s;
}

void CMenuItem::SetID(int i)
{
   id=i;
}

///////////////////////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////////////////////

CMenu::CMenu()
{
}

CMenu::~CMenu()
{
}

int CMenu::Add(CMenuItem& m)
{
	items.push_back(m);
	return 0;
}

int CMenu::Edit(CMenuItem& oldm, CMenuItem& newm)
{
   std::list<CMenuItem>::iterator mi=find(items.begin(), items.end(), oldm);
	
	if(mi==items.end()) return 1;
	*mi=newm;
	return 0;
}

int CMenu::Delete(CMenuItem& m)
{
	std::list<CMenuItem>::iterator mi=find(items.begin(), items.end(), m);
	
	if(mi==items.end()) return 1;
	
	items.erase(mi);
	return 0;
}

bool CMenu::Get(int id, CMenuItem *m)
{
   std::list<CMenuItem>::iterator mi=find(items.begin(), items.end(), id);
   
   if(mi!=items.end()){
      *m=*mi;
      return true;
   }
   return false;
}

int CMenu::Add(Glib::ustring& m)
{
	headings.push_back(m);
	return 0;
}

int CMenu::Edit(Glib::ustring& oldm, Glib::ustring& newm)
{
   std::list<Glib::ustring>::iterator mi=find(headings.begin(), headings.end(), oldm);
	
	if(mi==headings.end()) return 1;
	*mi=newm;
	return 0;
}

int CMenu::Delete(Glib::ustring& m)
{
	std::list<Glib::ustring>::iterator mi=find(headings.begin(), headings.end(), m);
	
	if(mi==headings.end()) return 1;
	
	headings.erase(mi);
	return 0;
}
/*
bool CMenu::Get(int id, Glib::ustring *m)
{
   std::list<Glib::ustring>::iterator mi=find(headings.begin(), headings.end(), m);
   
   if(mi!=headings.end()){
      *m=*mi;
      return true;
   }
   return false;
}*/

}
