/*
cmenulist.h
Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _BHMENULIST_
#define _BHMENULIST_

#include <glibmm/ustring.h>
#include <list>
#include <algorithm>

namespace BhPos{
	
/**
 * \defgroup menulist Menu Information
 * \@{
 *
 * \ingroup serverlib
 * \@{
 */

enum BhMenuStatus{
   BHMENU_STATUS_UNKNOWN=0,
   BHMENU_STATUS_NOTAVAILABLE,
   BHMENU_STATUS_AVAILABLE
};

class CMenuItem{
private:
   BhMenuStatus  status;
   int           id;
   int           menuid;
   int           menuheadingid;
   Glib::ustring plu;
   Glib::ustring name;
   Glib::ustring description;
   int           printerid;
   int           imageid;
   Glib::ustring rectext;

protected:
   std::list<Glib::ustring> options;

public:
	CMenuItem();
	CMenuItem(CMenuItem const&);
	~CMenuItem();
	void operator=(CMenuItem const&);
	bool operator==(CMenuItem const&);
	bool operator!=(CMenuItem const&);
   bool operator==(int);
	bool operator!=(int);

   BhMenuStatus GetStatus();
   int  GetID();

   void SetStatus(BhMenuStatus);
   void SetID(int);
};

class CMenu{
private:
	std::list<CMenuItem>     items;
   std::list<Glib::ustring> headings;
	
public:
	CMenu();
	~CMenu();
	int  Add(CMenuItem&);
	int  Edit(CMenuItem&, CMenuItem&);
	int  Delete(CMenuItem&);
   bool Get(int, CMenuItem *);
   int  Add(Glib::ustring&);
	int  Edit(Glib::ustring&, Glib::ustring&);
	int  Delete(Glib::ustring&);
   bool Get(int, Glib::ustring *);
};

/* }@
   }@ */
}

#endif // _BHPRNLIST_
