/*
module_coll.cpp
Copyright (C)2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.

*/
#include <dlfcn.h>
#include <dirent.h>
#include <cstdio>

#include "module.h"

#define _DEBUGGERY

namespace bhpos{

CModuleCollection::CModuleCollection()
{
}

CModuleCollection::CModuleCollection(CModuleCollection const& mc)
{
   Module=mc.Module;
}

void CModuleCollection::operator=(CModuleCollection const& mc)
{
   Module=mc.Module;
}
bool CModuleCollection::operator==(CModuleCollection const& mc)
{
   return false;
}
bool CModuleCollection::operator<(CModuleCollection const& mc)
{
   return false;
}

CModuleCollection::CModuleCollection(PLUServer *p, char *dir, void *arg, void *x, void *y, void *z)
{
   ScanDirectory(p, dir, arg, x, y, z);
}

CModuleCollection::~CModuleCollection()
{
   Close();
}

bool CModuleCollection::ScanDirectory(PLUServer *p, char *dir, void *arg, void *x, void *y, void *z)
{
   CModuleHandler handler;

   char           qual[255];
   DIR           *dp;
   struct dirent *ent;
   int				offset, status;
   bool           ret=true;

   strcpy(qual, dir);
   offset = strlen(dir);

	if(qual[offset-1] != '/')
		qual[offset++] = '/';

#ifdef _DEBUGGERY
   printf("Attempting to open directory %s.\n", dir);
#endif
   dp=opendir(dir);
   if(dp!=NULL){
      while((ent=readdir(dp))){
         if(ent==NULL){
             break;
         }
         if(ent->d_name){
            if((strcmp(ent->d_name, ".")!=0) && strcmp(ent->d_name, "..")!=0){
#ifdef _DEBUGGERY
               printf("Attempting load: %s.\n", ent->d_name);
#endif
					strcpy(qual+offset, ent->d_name);
               if((status=handler.Load(p, qual, arg, x, y, z))==0){
#ifdef _DEBUGGERY
                  printf("Loaded and Toaded.\n");
#endif
                  Module.push_back(handler);
                  ret=false;
               }
               else{
#ifdef _DEBUGGERY
                  printf("Loaded of %s Failed with:%d.\n", ent->d_name, status);
#endif                  
               }
            }
         }
      }
   }
   else{
#ifdef _DEBUGGERY
      printf("no directory.\n");
#endif   
      return true;
   }
   closedir(dp);
   return ret;
}

void CModuleCollection::Close()
{
   std::list<CModuleHandler>::iterator   i=Module.begin();
   CModuleHandler    m;

   while(i!=Module.end()){
      i->Unload();
      Module.pop_front();
   }
}

int CModuleCollection::HandleMsg(unsigned int msg_type, int len, void *data, int flags)
{
#ifdef _DEBUGGERY
   printf("cmodcoll: handles msg\n");
#endif
   if(Module.empty()) return -1;

   std::list<CModuleHandler>::iterator i;
   CModuleHandler                      m;

#ifdef _DEBUGGERY
   printf("cmodcoll: non empty list\n");
#endif
   
   for(i=Module.begin(); i!=Module.end(); i++){
      if(i->CanHandle(msg_type)){
         //return i->Process(msg_type, len, data, flags);
         m=*i;
         return m.Process(msg_type, len, data, flags);
      }
   }
   return -2;
}

}
