/*
cprnlist.cpp
Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/

#include <sys/time.h>
#include "cprnlist.h"

namespace bhpos{

CRPrinter::CRPrinter()
{
   status=BHRPRN_STATUS_UNKNOWN;
   ID=0;
	memset(&sin, 0, sizeof(sin));
}

CRPrinter::CRPrinter(CRPrinter const& p)
{
   status=p.status;
   ID=p.ID;
   memcpy(&sin, &p.sin, sizeof(sin));
}

CRPrinter::CRPrinter(int i, char *h, unsigned short p)
{
   status=BHRPRN_STATUS_UNKNOWN;
   
	memset(&sin, 0, sizeof(sin));
	sin.sin_family=AF_INET;
	sin.sin_addr.s_addr=inet_addr(h);
	sin.sin_port=htons(p);
   
   ID=i;
}

CRPrinter::~CRPrinter()
{
}

void CRPrinter::operator=(CRPrinter const& p)
{
   status=p.status;
   memcpy(&sin, &p.sin, sizeof(sin));
}

bool CRPrinter::operator==(CRPrinter const& p)
{
	if(ID==p.ID) return true;
	return false;
}

bool CRPrinter::operator==(int i)
{
	if(ID==i) return true;
	return false;
}

bool CRPrinter::operator!=(int i)
{
	if(ID!=i) return true;
	return false;
}

bool CRPrinter::operator!=(CRPrinter const& p)
{
	if(ID!=p.ID) return true;
	return false;
}
BhRPrinterStatus CRPrinter::GetStatus()
{
   return status;
}

int CRPrinter::GetID()
{
   return ID;
}

void CRPrinter::GetAddress(sockaddr_in *s)
{
   memcpy(&s, &sin, sizeof(sin));
}

void CRPrinter::SetStatus(BhRPrinterStatus s)
{
   status=s;
}

void CRPrinter::SetAddress(sockaddr_in *s)
{
   memcpy(&sin, &s, sizeof(sin));
}

void CRPrinter::SetID(int i)
{
   ID=i;
}

///////////////////////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////////////////////

CPrinterList::CPrinterList()
{
}

CPrinterList::~CPrinterList()
{
}

int CPrinterList::Add(CRPrinter& p)
{
	printers.push_back(p);
	return 0;
}

int CPrinterList::Edit(CRPrinter& oldo, CRPrinter& newp)
{
	return 0;
}

int CPrinterList::Delete(CRPrinter& p)
{
	std::list<CRPrinter>::iterator pi=find(printers.begin(), printers.end(), p);
	
	if(pi==printers.end()) return 1;
	
	printers.erase(pi);
	return 0;
}

bool CPrinterList::Get(int id, CRPrinter *p)
{
   std::list<CRPrinter>::iterator pi=find(printers.begin(), printers.end(), id);
   
   if(pi!=printers.end()){
      *p=*pi;
      return true;
   }
   return false;
}

}
