/*
cprnlist.h
Copyright (C)2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/

#ifndef _BHPRNLIST_
#define _BHPRNLIST_

#include <netinet/in.h>
#include <arpa/inet.h>
#include <list>
#include <algorithm>

namespace bhpos{
	
/**
 * \defgroup prn Printer Information
 * \@{
 *
 * \ingroup serverlib
 * \@{
 */

enum BhRPrinterStatus{
   BHRPRN_STATUS_UNKNOWN=0,
   BHRPRN_STATUS_ONLINE,
   BHRPRN_STATUS_OFFLINE,
   BHRPRN_STATUS_ERROR
};

class CRPrinter{
private:
   BhRPrinterStatus status;
   int              ID;
	sockaddr_in      sin;
	
public:
	CRPrinter();
	CRPrinter(CRPrinter const&);
	CRPrinter(int, char *, unsigned short);
	~CRPrinter();
	void operator=(CRPrinter const&);
	bool operator==(CRPrinter const&);
	bool operator!=(CRPrinter const&);
   bool operator==(int);
	bool operator!=(int);

   BhRPrinterStatus GetStatus();
   int  GetID();
   void GetAddress(sockaddr_in *);

   void SetStatus(BhRPrinterStatus );
   void SetID(int);
   void SetAddress(sockaddr_in *);
};

class CPrinterList{
private:
	std::list<CRPrinter> printers;
	
public:
	CPrinterList();
	~CPrinterList();
	
	int Add(CRPrinter&);
	int Edit(CRPrinter&, CRPrinter&);
	int Delete(CRPrinter&);
   
   bool Get(int, CRPrinter *);
};

/* }@
   }@ */
}

#endif // _BHPRNLIST_
